"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __commonJS = (cb, mod) => function __require() {
  return mod || (0, cb[__getOwnPropNames(cb)[0]])((mod = { exports: {} }).exports, mod), mod.exports;
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));

// node_modules/rimraf/rimraf.js
var require_rimraf = __commonJS({
  "node_modules/rimraf/rimraf.js"(exports, module2) {
    "use strict";
    var assert = require("assert");
    var path = require("path");
    var fs = require("fs");
    var glob = void 0;
    try {
      glob = require("glob");
    } catch (_err) {
    }
    var defaultGlobOpts = {
      nosort: true,
      silent: true
    };
    var timeout = 0;
    var isWindows = process.platform === "win32";
    var defaults = (options) => {
      const methods = [
        "unlink",
        "chmod",
        "stat",
        "lstat",
        "rmdir",
        "readdir"
      ];
      methods.forEach((m) => {
        options[m] = options[m] || fs[m];
        m = m + "Sync";
        options[m] = options[m] || fs[m];
      });
      options.maxBusyTries = options.maxBusyTries || 3;
      options.emfileWait = options.emfileWait || 1e3;
      if (options.glob === false) {
        options.disableGlob = true;
      }
      if (options.disableGlob !== true && glob === void 0) {
        throw Error("glob dependency not found, set `options.disableGlob = true` if intentional");
      }
      options.disableGlob = options.disableGlob || false;
      options.glob = options.glob || defaultGlobOpts;
    };
    var rimraf2 = (p, options, cb) => {
      if (typeof options === "function") {
        cb = options;
        options = {};
      }
      assert(p, "rimraf: missing path");
      assert.equal(typeof p, "string", "rimraf: path should be a string");
      assert.equal(typeof cb, "function", "rimraf: callback function required");
      assert(options, "rimraf: invalid options argument provided");
      assert.equal(typeof options, "object", "rimraf: options should be object");
      defaults(options);
      let busyTries = 0;
      let errState = null;
      let n = 0;
      const next = (er) => {
        errState = errState || er;
        if (--n === 0)
          cb(errState);
      };
      const afterGlob = (er, results) => {
        if (er)
          return cb(er);
        n = results.length;
        if (n === 0)
          return cb();
        results.forEach((p2) => {
          const CB = (er2) => {
            if (er2) {
              if ((er2.code === "EBUSY" || er2.code === "ENOTEMPTY" || er2.code === "EPERM") && busyTries < options.maxBusyTries) {
                busyTries++;
                return setTimeout(() => rimraf_(p2, options, CB), busyTries * 100);
              }
              if (er2.code === "EMFILE" && timeout < options.emfileWait) {
                return setTimeout(() => rimraf_(p2, options, CB), timeout++);
              }
              if (er2.code === "ENOENT")
                er2 = null;
            }
            timeout = 0;
            next(er2);
          };
          rimraf_(p2, options, CB);
        });
      };
      if (options.disableGlob || !glob.hasMagic(p))
        return afterGlob(null, [p]);
      options.lstat(p, (er, stat) => {
        if (!er)
          return afterGlob(null, [p]);
        glob(p, options.glob, afterGlob);
      });
    };
    var rimraf_ = (p, options, cb) => {
      assert(p);
      assert(options);
      assert(typeof cb === "function");
      options.lstat(p, (er, st) => {
        if (er && er.code === "ENOENT")
          return cb(null);
        if (er && er.code === "EPERM" && isWindows)
          fixWinEPERM(p, options, er, cb);
        if (st && st.isDirectory())
          return rmdir(p, options, er, cb);
        options.unlink(p, (er2) => {
          if (er2) {
            if (er2.code === "ENOENT")
              return cb(null);
            if (er2.code === "EPERM")
              return isWindows ? fixWinEPERM(p, options, er2, cb) : rmdir(p, options, er2, cb);
            if (er2.code === "EISDIR")
              return rmdir(p, options, er2, cb);
          }
          return cb(er2);
        });
      });
    };
    var fixWinEPERM = (p, options, er, cb) => {
      assert(p);
      assert(options);
      assert(typeof cb === "function");
      options.chmod(p, 438, (er2) => {
        if (er2)
          cb(er2.code === "ENOENT" ? null : er);
        else
          options.stat(p, (er3, stats) => {
            if (er3)
              cb(er3.code === "ENOENT" ? null : er);
            else if (stats.isDirectory())
              rmdir(p, options, er, cb);
            else
              options.unlink(p, cb);
          });
      });
    };
    var fixWinEPERMSync = (p, options, er) => {
      assert(p);
      assert(options);
      try {
        options.chmodSync(p, 438);
      } catch (er2) {
        if (er2.code === "ENOENT")
          return;
        else
          throw er;
      }
      let stats;
      try {
        stats = options.statSync(p);
      } catch (er3) {
        if (er3.code === "ENOENT")
          return;
        else
          throw er;
      }
      if (stats.isDirectory())
        rmdirSync(p, options, er);
      else
        options.unlinkSync(p);
    };
    var rmdir = (p, options, originalEr, cb) => {
      assert(p);
      assert(options);
      assert(typeof cb === "function");
      options.rmdir(p, (er) => {
        if (er && (er.code === "ENOTEMPTY" || er.code === "EEXIST" || er.code === "EPERM"))
          rmkids(p, options, cb);
        else if (er && er.code === "ENOTDIR")
          cb(originalEr);
        else
          cb(er);
      });
    };
    var rmkids = (p, options, cb) => {
      assert(p);
      assert(options);
      assert(typeof cb === "function");
      options.readdir(p, (er, files) => {
        if (er)
          return cb(er);
        let n = files.length;
        if (n === 0)
          return options.rmdir(p, cb);
        let errState;
        files.forEach((f) => {
          rimraf2(path.join(p, f), options, (er2) => {
            if (errState)
              return;
            if (er2)
              return cb(errState = er2);
            if (--n === 0)
              options.rmdir(p, cb);
          });
        });
      });
    };
    var rimrafSync = (p, options) => {
      options = options || {};
      defaults(options);
      assert(p, "rimraf: missing path");
      assert.equal(typeof p, "string", "rimraf: path should be a string");
      assert(options, "rimraf: missing options");
      assert.equal(typeof options, "object", "rimraf: options should be object");
      let results;
      if (options.disableGlob || !glob.hasMagic(p)) {
        results = [p];
      } else {
        try {
          options.lstatSync(p);
          results = [p];
        } catch (er) {
          results = glob.sync(p, options.glob);
        }
      }
      if (!results.length)
        return;
      for (let i = 0; i < results.length; i++) {
        const p2 = results[i];
        let st;
        try {
          st = options.lstatSync(p2);
        } catch (er) {
          if (er.code === "ENOENT")
            return;
          if (er.code === "EPERM" && isWindows)
            fixWinEPERMSync(p2, options, er);
        }
        try {
          if (st && st.isDirectory())
            rmdirSync(p2, options, null);
          else
            options.unlinkSync(p2);
        } catch (er) {
          if (er.code === "ENOENT")
            return;
          if (er.code === "EPERM")
            return isWindows ? fixWinEPERMSync(p2, options, er) : rmdirSync(p2, options, er);
          if (er.code !== "EISDIR")
            throw er;
          rmdirSync(p2, options, er);
        }
      }
    };
    var rmdirSync = (p, options, originalEr) => {
      assert(p);
      assert(options);
      try {
        options.rmdirSync(p);
      } catch (er) {
        if (er.code === "ENOENT")
          return;
        if (er.code === "ENOTDIR")
          throw originalEr;
        if (er.code === "ENOTEMPTY" || er.code === "EEXIST" || er.code === "EPERM")
          rmkidsSync(p, options);
      }
    };
    var rmkidsSync = (p, options) => {
      assert(p);
      assert(options);
      options.readdirSync(p).forEach((f) => rimrafSync(path.join(p, f), options));
      const retries = isWindows ? 100 : 1;
      let i = 0;
      do {
        let threw = true;
        try {
          const ret = options.rmdirSync(p, options);
          threw = false;
          return ret;
        } finally {
          if (++i < retries && threw)
            continue;
        }
      } while (true);
    };
    module2.exports = rimraf2;
    rimraf2.sync = rimrafSync;
  }
});

// test/testCLI.ts
var import_ava = __toESM(require("ava"), 1);
var import_child_process = require("child_process");
var import_fs = require("fs");
var import_path = require("path");
var rimraf = require_rimraf();
function run() {
  (0, import_ava.default)("pipe in, pipe out", (t) => {
    t.snapshot(
      (0, import_child_process.execSync)("shx cat ./test/resources/ReferencedType.json | node dist/cli.cjs", { encoding: "utf-8" }).toString()
    );
  });
  (0, import_ava.default)("pipe in (schema without ID), pipe out", (t) => {
    t.snapshot(
      (0, import_child_process.execSync)("shx cat ./test/resources/ReferencedTypeWithoutID.json | node dist/cli.cjs", {
        encoding: "utf-8"
      }).toString()
    );
  });
  (0, import_ava.default)("file in (no flags), pipe out", (t) => {
    t.snapshot((0, import_child_process.execSync)("node dist/cli.cjs ./test/resources/ReferencedType.json").toString());
  });
  (0, import_ava.default)("file in (--input), pipe out", (t) => {
    t.snapshot((0, import_child_process.execSync)("node dist/cli.cjs --input ./test/resources/ReferencedType.json").toString());
  });
  (0, import_ava.default)("file in (-i), pipe out", (t) => {
    t.snapshot((0, import_child_process.execSync)("node dist/cli.cjs -i ./test/resources/ReferencedType.json").toString());
  });
  (0, import_ava.default)("file in (-i), unreachable definitions flag, pipe out", (t) => {
    t.snapshot(
      (0, import_child_process.execSync)("node dist/cli.cjs -i ./test/resources/DefinitionsOnly.json --unreachableDefinitions").toString()
    );
  });
  (0, import_ava.default)("file in (-i), style flags, pipe out", (t) => {
    t.snapshot(
      (0, import_child_process.execSync)("node dist/cli.cjs -i ./test/resources/Enum.json --style.singleQuote --no-style.semi").toString()
    );
  });
  (0, import_ava.default)("file in (-i), pipe out (absolute path)", (t) => {
    t.snapshot((0, import_child_process.execSync)(`node dist/cli.cjs -i ${__dirname}/../test/resources/ReferencedType.json`).toString());
  });
  (0, import_ava.default)("pipe in, file out (--output)", (t) => {
    (0, import_child_process.execSync)("shx cat ./test/resources/ReferencedType.json | node dist/cli.cjs --output ./ReferencedType.d.ts");
    t.snapshot((0, import_fs.readFileSync)("./ReferencedType.d.ts", "utf-8"));
    (0, import_fs.unlinkSync)("./ReferencedType.d.ts");
  });
  (0, import_ava.default)("pipe in, file out (-o)", (t) => {
    (0, import_child_process.execSync)("shx cat ./test/resources/ReferencedType.json | node dist/cli.cjs -o ./ReferencedType.d.ts");
    t.snapshot((0, import_fs.readFileSync)("./ReferencedType.d.ts", "utf-8"));
    (0, import_fs.unlinkSync)("./ReferencedType.d.ts");
  });
  (0, import_ava.default)("file in (no flags), file out (no flags)", (t) => {
    (0, import_child_process.execSync)("node dist/cli.cjs ./test/resources/ReferencedType.json ./ReferencedType.d.ts");
    t.snapshot((0, import_fs.readFileSync)("./ReferencedType.d.ts", "utf-8"));
    (0, import_fs.unlinkSync)("./ReferencedType.d.ts");
  });
  (0, import_ava.default)("file in (-i), file out (-o)", (t) => {
    (0, import_child_process.execSync)("node dist/cli.cjs -i ./test/resources/ReferencedType.json -o ./ReferencedType.d.ts");
    t.snapshot((0, import_fs.readFileSync)("./ReferencedType.d.ts", "utf-8"));
    (0, import_fs.unlinkSync)("./ReferencedType.d.ts");
  });
  (0, import_ava.default)("file in (--input), file out (--output)", (t) => {
    (0, import_child_process.execSync)("node dist/cli.cjs --input ./test/resources/ReferencedType.json --output ./ReferencedType.d.ts");
    t.snapshot((0, import_fs.readFileSync)("./ReferencedType.d.ts", "utf-8"));
    (0, import_fs.unlinkSync)("./ReferencedType.d.ts");
  });
  (0, import_ava.default)("--unknownAny", (t) => {
    t.snapshot((0, import_child_process.execSync)("node dist/cli.cjs --unknownAny=false --input ./test/resources/ReferencedType.json").toString());
  });
  (0, import_ava.default)("--additionalProperties", (t) => {
    t.snapshot(
      (0, import_child_process.execSync)(
        "node dist/cli.cjs --additionalProperties=false --input ./test/resources/ReferencedType.json"
      ).toString()
    );
  });
  (0, import_ava.default)("files in (-i), files out (-o)", (t) => {
    (0, import_child_process.execSync)(`node dist/cli.cjs -i "./test/resources/MultiSchema/**/*.json" -o ./test/resources/MultiSchema/out`);
    (0, import_fs.readdirSync)("./test/resources/MultiSchema/out").forEach((f) => {
      const path = `./test/resources/MultiSchema/out/${f}`;
      t.snapshot(path);
      t.snapshot((0, import_fs.readFileSync)(path, "utf-8"));
      (0, import_fs.unlinkSync)(path);
    });
    rimraf.sync("./test/resources/MultiSchema/out");
  });
  (0, import_ava.default)("files in (-i), pipe out", (t) => {
    t.snapshot((0, import_child_process.execSync)(`node dist/cli.cjs -i "./test/resources/MultiSchema/**/*.json"`).toString());
  });
  (0, import_ava.default)("files in (-i), files out (-o) nested dir does not exist", (t) => {
    (0, import_child_process.execSync)(
      `node dist/cli.cjs -i "./test/resources/MultiSchema/**/*.json" -o ./test/resources/MultiSchema/foo/bar/out`
    );
    (0, import_fs.readdirSync)("./test/resources/MultiSchema/foo/bar/out").forEach((f) => {
      const path = `./test/resources/MultiSchema/foo/bar/out/${f}`;
      t.snapshot(path);
      t.snapshot((0, import_fs.readFileSync)(path, "utf-8"));
      (0, import_fs.unlinkSync)(path);
    });
    rimraf.sync("./test/resources/MultiSchema/foo");
  });
  (0, import_ava.default)("files in (-i), files out (-o) matching nested dir", (t) => {
    (0, import_child_process.execSync)(
      `node dist/cli.cjs -i "./test/resources/../../test/resources/MultiSchema2/" -o ./test/resources/MultiSchema2/out`
    );
    getPaths("./test/resources/MultiSchema2/out").forEach((file) => {
      t.snapshot(file);
      t.snapshot((0, import_fs.readFileSync)(file, "utf-8"));
      (0, import_fs.unlinkSync)(file);
    });
    rimraf.sync("./test/resources/MultiSchema2/out");
  });
}
function getPaths(path, paths = []) {
  if ((0, import_fs.existsSync)(path) && (0, import_fs.lstatSync)(path).isDirectory()) {
    (0, import_fs.readdirSync)((0, import_path.resolve)(path)).forEach((item) => getPaths(import_path.posix.join(import_path.posix.normalize(path), item), paths));
  } else {
    paths.push(path);
  }
  return paths.sort((a, b) => a.localeCompare(b));
}

// test/testCompileFromFile.ts
var import_ava2 = __toESM(require("ava"), 1);

// src/index.ts
var import_fs2 = require("fs");
var import_lodash8 = require("lodash");
var import_path3 = require("path");

// src/formatter.ts
var import_prettier = require("prettier");
function format(code, options) {
  if (!options.format) {
    return code;
  }
  return (0, import_prettier.format)(code, { parser: "typescript", ...options.style });
}

// src/generator.ts
var import_lodash3 = require("lodash");

// src/types/AST.ts
function hasComment(ast) {
  return "comment" in ast && ast.comment != null && ast.comment !== "" || // Compare to true because ast.deprecated might be undefined
  "deprecated" in ast && ast.deprecated === true;
}
function hasStandaloneName(ast) {
  return "standaloneName" in ast && ast.standaloneName != null && ast.standaloneName !== "";
}
var T_ANY = {
  type: "ANY"
};
var T_ANY_ADDITIONAL_PROPERTIES = {
  keyName: "[k: string]",
  type: "ANY"
};
var T_UNKNOWN = {
  type: "UNKNOWN"
};
var T_UNKNOWN_ADDITIONAL_PROPERTIES = {
  keyName: "[k: string]",
  type: "UNKNOWN"
};

// src/utils.ts
var import_lodash2 = require("lodash");
var import_path2 = require("path");

// src/types/JSONSchema.ts
var import_lodash = require("lodash");
var Parent = Symbol("Parent");
var getRootSchema = (0, import_lodash.memoize)((schema) => {
  const parent = schema[Parent];
  if (!parent) {
    return schema;
  }
  return getRootSchema(parent);
});
function isBoolean(schema) {
  return schema === true || schema === false;
}
function isPrimitive(schema) {
  return !(0, import_lodash.isPlainObject)(schema);
}
function isCompound(schema) {
  return Array.isArray(schema.type) || "anyOf" in schema || "oneOf" in schema;
}

// src/utils.ts
function Try(fn, err) {
  try {
    return fn();
  } catch (e) {
    return err(e);
  }
}
var BLACKLISTED_KEYS = /* @__PURE__ */ new Set([
  "id",
  "$defs",
  "$id",
  "$schema",
  "title",
  "description",
  "default",
  "multipleOf",
  "maximum",
  "exclusiveMaximum",
  "minimum",
  "exclusiveMinimum",
  "maxLength",
  "minLength",
  "pattern",
  "additionalItems",
  "items",
  "maxItems",
  "minItems",
  "uniqueItems",
  "maxProperties",
  "minProperties",
  "required",
  "additionalProperties",
  "definitions",
  "properties",
  "patternProperties",
  "dependencies",
  "enum",
  "type",
  "allOf",
  "anyOf",
  "oneOf",
  "not"
]);
function traverseObjectKeys(obj, callback, processed) {
  Object.keys(obj).forEach((k) => {
    if (obj[k] && typeof obj[k] === "object" && !Array.isArray(obj[k])) {
      traverse(obj[k], callback, processed, k);
    }
  });
}
function traverseArray(arr, callback, processed) {
  arr.forEach((s, k) => traverse(s, callback, processed, k.toString()));
}
function traverse(schema, callback, processed = /* @__PURE__ */ new Set(), key) {
  if (processed.has(schema)) {
    return;
  }
  processed.add(schema);
  callback(schema, key ?? null);
  if (schema.anyOf) {
    traverseArray(schema.anyOf, callback, processed);
  }
  if (schema.allOf) {
    traverseArray(schema.allOf, callback, processed);
  }
  if (schema.oneOf) {
    traverseArray(schema.oneOf, callback, processed);
  }
  if (schema.properties) {
    traverseObjectKeys(schema.properties, callback, processed);
  }
  if (schema.patternProperties) {
    traverseObjectKeys(schema.patternProperties, callback, processed);
  }
  if (schema.additionalProperties && typeof schema.additionalProperties === "object") {
    traverse(schema.additionalProperties, callback, processed);
  }
  if (schema.items) {
    const { items } = schema;
    if (Array.isArray(items)) {
      traverseArray(items, callback, processed);
    } else {
      traverse(items, callback, processed);
    }
  }
  if (schema.additionalItems && typeof schema.additionalItems === "object") {
    traverse(schema.additionalItems, callback, processed);
  }
  if (schema.dependencies) {
    if (Array.isArray(schema.dependencies)) {
      traverseArray(schema.dependencies, callback, processed);
    } else {
      traverseObjectKeys(schema.dependencies, callback, processed);
    }
  }
  if (schema.definitions) {
    traverseObjectKeys(schema.definitions, callback, processed);
  }
  if (schema.$defs) {
    traverseObjectKeys(schema.$defs, callback, processed);
  }
  if (schema.not) {
    traverse(schema.not, callback, processed);
  }
  Object.keys(schema).filter((key2) => !BLACKLISTED_KEYS.has(key2)).forEach((key2) => {
    const child = schema[key2];
    if (child && typeof child === "object") {
      traverseObjectKeys(child, callback, processed);
    }
  });
}
function justName(filename = "") {
  return stripExtension((0, import_path2.basename)(filename));
}
function stripExtension(filename) {
  return filename.replace((0, import_path2.extname)(filename), "");
}
function toSafeString(string) {
  return (0, import_lodash2.upperFirst)(
    // remove accents, umlauts, ... by their basic latin letters
    (0, import_lodash2.deburr)(string).replace(/(^\s*[^a-zA-Z_$])|([^a-zA-Z_$\d])/g, " ").replace(/^_[a-z]/g, (match) => match.toUpperCase()).replace(/_[a-z]/g, (match) => match.substr(1, match.length).toUpperCase()).replace(/([\d$]+[a-zA-Z])/g, (match) => match.toUpperCase()).replace(/\s+([a-zA-Z])/g, (match) => (0, import_lodash2.trim)(match.toUpperCase())).replace(/\s/g, "")
  );
}
function generateName(from, usedNames) {
  let name = toSafeString(from);
  if (!name) {
    name = "NoName";
  }
  if (usedNames.has(name)) {
    let counter = 1;
    let nameWithCounter = `${name}${counter}`;
    while (usedNames.has(nameWithCounter)) {
      nameWithCounter = `${name}${counter}`;
      counter++;
    }
    name = nameWithCounter;
  }
  usedNames.add(name);
  return name;
}
function error(...messages) {
  if (!process.env.VERBOSE) {
    return console.error(messages);
  }
  console.error(getStyledTextForLogging("red")?.("error"), ...messages);
}
function log(style, title, ...messages) {
  if (!process.env.VERBOSE) {
    return;
  }
  let lastMessage = null;
  if (messages.length > 1 && typeof messages[messages.length - 1] !== "string") {
    lastMessage = messages.splice(messages.length - 1, 1);
  }
  console.info(require("cli-color").whiteBright.bgCyan("debug"), getStyledTextForLogging(style)?.(title), ...messages);
  if (lastMessage) {
    console.dir(lastMessage, { depth: 6, maxArrayLength: 6 });
  }
}
function getStyledTextForLogging(style) {
  if (!process.env.VERBOSE) {
    return;
  }
  switch (style) {
    case "blue":
      return require("cli-color").whiteBright.bgBlue;
    case "cyan":
      return require("cli-color").whiteBright.bgCyan;
    case "green":
      return require("cli-color").whiteBright.bgGreen;
    case "magenta":
      return require("cli-color").whiteBright.bgMagenta;
    case "red":
      return require("cli-color").whiteBright.bgRedBright;
    case "white":
      return require("cli-color").black.bgWhite;
    case "yellow":
      return require("cli-color").whiteBright.bgYellow;
  }
}
function escapeBlockComment(schema) {
  const replacer = "* /";
  if (schema === null || typeof schema !== "object") {
    return;
  }
  for (const key of Object.keys(schema)) {
    if (key === "description" && typeof schema[key] === "string") {
      schema[key] = schema[key].replace(/\*\//g, replacer);
    }
  }
}
function pathTransform(outputPath, inputPath, filePath) {
  const inPathList = (0, import_path2.normalize)(inputPath).split(import_path2.sep);
  const filePathList = (0, import_path2.dirname)((0, import_path2.normalize)(filePath)).split(import_path2.sep);
  const filePathRel = filePathList.filter((f, i) => f !== inPathList[i]);
  return import_path2.posix.join(import_path2.posix.normalize(outputPath), ...filePathRel);
}
function maybeStripDefault(schema) {
  if (!("default" in schema)) {
    return schema;
  }
  switch (schema.type) {
    case "array":
      if (Array.isArray(schema.default)) {
        return schema;
      }
      break;
    case "boolean":
      if (typeof schema.default === "boolean") {
        return schema;
      }
      break;
    case "integer":
    case "number":
      if (typeof schema.default === "number") {
        return schema;
      }
      break;
    case "string":
      if (typeof schema.default === "string") {
        return schema;
      }
      break;
    case "null":
      if (schema.default === null) {
        return schema;
      }
      break;
    case "object":
      if ((0, import_lodash2.isPlainObject)(schema.default)) {
        return schema;
      }
      break;
  }
  delete schema.default;
  return schema;
}
function maybeStripNameHints(schema) {
  if ("$id" in schema) {
    delete schema.$id;
  }
  if ("description" in schema) {
    delete schema.description;
  }
  if ("name" in schema) {
    delete schema.name;
  }
  return schema;
}
function appendToDescription(existingDescription, ...values) {
  if (existingDescription) {
    return `${existingDescription}

${values.join("\n")}`;
  }
  return values.join("\n");
}
function isSchemaLike(schema) {
  if (!(0, import_lodash2.isPlainObject)(schema)) {
    return false;
  }
  const parent = schema[Parent];
  if (parent === null) {
    return true;
  }
  const JSON_SCHEMA_KEYWORDS = [
    "$defs",
    "allOf",
    "anyOf",
    "definitions",
    "dependencies",
    "enum",
    "not",
    "oneOf",
    "patternProperties",
    "properties",
    "required"
  ];
  if (JSON_SCHEMA_KEYWORDS.some((_) => parent[_] === schema)) {
    return false;
  }
  return true;
}

// src/generator.ts
function generate(ast, options = DEFAULT_OPTIONS) {
  return [
    options.bannerComment,
    declareNamedTypes(ast, options, ast.standaloneName),
    declareNamedInterfaces(ast, options, ast.standaloneName),
    declareEnums(ast, options)
  ].filter(Boolean).join("\n\n") + "\n";
}
function declareEnums(ast, options, processed = /* @__PURE__ */ new Set()) {
  if (processed.has(ast)) {
    return "";
  }
  processed.add(ast);
  let type = "";
  switch (ast.type) {
    case "ENUM":
      return generateStandaloneEnum(ast, options) + "\n";
    case "ARRAY":
      return declareEnums(ast.params, options, processed);
    case "UNION":
    case "INTERSECTION":
      return ast.params.reduce((prev, ast2) => prev + declareEnums(ast2, options, processed), "");
    case "TUPLE":
      type = ast.params.reduce((prev, ast2) => prev + declareEnums(ast2, options, processed), "");
      if (ast.spreadParam) {
        type += declareEnums(ast.spreadParam, options, processed);
      }
      return type;
    case "INTERFACE":
      return getSuperTypesAndParams(ast).reduce((prev, ast2) => prev + declareEnums(ast2, options, processed), "");
    default:
      return "";
  }
}
function declareNamedInterfaces(ast, options, rootASTName, processed = /* @__PURE__ */ new Set()) {
  if (processed.has(ast)) {
    return "";
  }
  processed.add(ast);
  let type = "";
  switch (ast.type) {
    case "ARRAY":
      type = declareNamedInterfaces(ast.params, options, rootASTName, processed);
      break;
    case "INTERFACE":
      type = [
        hasStandaloneName(ast) && (ast.standaloneName === rootASTName || options.declareExternallyReferenced) && generateStandaloneInterface(ast, options),
        getSuperTypesAndParams(ast).map((ast2) => declareNamedInterfaces(ast2, options, rootASTName, processed)).filter(Boolean).join("\n")
      ].filter(Boolean).join("\n");
      break;
    case "INTERSECTION":
    case "TUPLE":
    case "UNION":
      type = ast.params.map((_) => declareNamedInterfaces(_, options, rootASTName, processed)).filter(Boolean).join("\n");
      if (ast.type === "TUPLE" && ast.spreadParam) {
        type += declareNamedInterfaces(ast.spreadParam, options, rootASTName, processed);
      }
      break;
    default:
      type = "";
  }
  return type;
}
function declareNamedTypes(ast, options, rootASTName, processed = /* @__PURE__ */ new Set()) {
  if (processed.has(ast)) {
    return "";
  }
  processed.add(ast);
  switch (ast.type) {
    case "ARRAY":
      return [
        declareNamedTypes(ast.params, options, rootASTName, processed),
        hasStandaloneName(ast) ? generateStandaloneType(ast, options) : void 0
      ].filter(Boolean).join("\n");
    case "ENUM":
      return "";
    case "INTERFACE":
      return getSuperTypesAndParams(ast).map(
        (ast2) => (ast2.standaloneName === rootASTName || options.declareExternallyReferenced) && declareNamedTypes(ast2, options, rootASTName, processed)
      ).filter(Boolean).join("\n");
    case "INTERSECTION":
    case "TUPLE":
    case "UNION":
      return [
        hasStandaloneName(ast) ? generateStandaloneType(ast, options) : void 0,
        ast.params.map((ast2) => declareNamedTypes(ast2, options, rootASTName, processed)).filter(Boolean).join("\n"),
        "spreadParam" in ast && ast.spreadParam ? declareNamedTypes(ast.spreadParam, options, rootASTName, processed) : void 0
      ].filter(Boolean).join("\n");
    default:
      if (hasStandaloneName(ast)) {
        return generateStandaloneType(ast, options);
      }
      return "";
  }
}
function generateTypeUnmemoized(ast, options) {
  const type = generateRawType(ast, options);
  if (options.strictIndexSignatures && ast.keyName === "[k: string]") {
    return `${type} | undefined`;
  }
  return type;
}
var generateType = (0, import_lodash3.memoize)(generateTypeUnmemoized);
function generateRawType(ast, options) {
  log("magenta", "generator", ast);
  if (hasStandaloneName(ast)) {
    return toSafeString(ast.standaloneName);
  }
  switch (ast.type) {
    case "ANY":
      return "any";
    case "ARRAY":
      return (() => {
        const type = generateType(ast.params, options);
        return type.endsWith('"') ? "(" + type + ")[]" : type + "[]";
      })();
    case "BOOLEAN":
      return "boolean";
    case "INTERFACE":
      return generateInterface(ast, options);
    case "INTERSECTION":
      return generateSetOperation(ast, options);
    case "LITERAL":
      return JSON.stringify(ast.params);
    case "NEVER":
      return "never";
    case "NUMBER":
      return "number";
    case "NULL":
      return "null";
    case "OBJECT":
      return "object";
    case "REFERENCE":
      return ast.params;
    case "STRING":
      return "string";
    case "TUPLE":
      return (() => {
        const minItems = ast.minItems;
        const maxItems = ast.maxItems || -1;
        let spreadParam = ast.spreadParam;
        const astParams = [...ast.params];
        if (minItems > 0 && minItems > astParams.length && ast.spreadParam === void 0) {
          if (maxItems < 0) {
            spreadParam = options.unknownAny ? T_UNKNOWN : T_ANY;
          }
        }
        if (maxItems > astParams.length && ast.spreadParam === void 0) {
          for (let i = astParams.length; i < maxItems; i += 1) {
            astParams.push(options.unknownAny ? T_UNKNOWN : T_ANY);
          }
        }
        function addSpreadParam(params) {
          if (spreadParam) {
            const spread = "...(" + generateType(spreadParam, options) + ")[]";
            params.push(spread);
          }
          return params;
        }
        function paramsToString(params) {
          return "[" + params.join(", ") + "]";
        }
        const paramsList = astParams.map((param) => generateType(param, options));
        if (paramsList.length > minItems) {
          const cumulativeParamsList = paramsList.slice(0, minItems);
          const typesToUnion = [];
          if (cumulativeParamsList.length > 0) {
            typesToUnion.push(paramsToString(cumulativeParamsList));
          } else {
            typesToUnion.push(paramsToString([]));
          }
          for (let i = minItems; i < paramsList.length; i += 1) {
            cumulativeParamsList.push(paramsList[i]);
            if (i === paramsList.length - 1) {
              addSpreadParam(cumulativeParamsList);
            }
            typesToUnion.push(paramsToString(cumulativeParamsList));
          }
          return typesToUnion.join("|");
        }
        return paramsToString(addSpreadParam(paramsList));
      })();
    case "UNION":
      return generateSetOperation(ast, options);
    case "UNKNOWN":
      return "unknown";
    case "CUSTOM_TYPE":
      return ast.params;
  }
}
function generateSetOperation(ast, options) {
  const members = ast.params.map((_) => generateType(_, options));
  const separator = ast.type === "UNION" ? "|" : "&";
  return members.length === 1 ? members[0] : "(" + members.join(" " + separator + " ") + ")";
}
function generateInterface(ast, options) {
  return `{
` + ast.params.filter((_) => !_.isPatternProperty && !_.isUnreachableDefinition).map(
    ({ isRequired, keyName, ast: ast2 }) => [isRequired, keyName, ast2, generateType(ast2, options)]
  ).map(
    ([isRequired, keyName, ast2, type]) => (hasComment(ast2) && !ast2.standaloneName ? generateComment(ast2.comment, ast2.deprecated) + "\n" : "") + escapeKeyName(keyName) + (isRequired ? "" : "?") + ": " + type
  ).join("\n") + "\n}";
}
function generateComment(comment, deprecated) {
  const commentLines = ["/**"];
  if (deprecated) {
    commentLines.push(" * @deprecated");
  }
  if (typeof comment !== "undefined") {
    commentLines.push(...comment.split("\n").map((_) => " * " + _));
  }
  commentLines.push(" */");
  return commentLines.join("\n");
}
function generateStandaloneEnum(ast, options) {
  return (hasComment(ast) ? generateComment(ast.comment, ast.deprecated) + "\n" : "") + "export " + (options.enableConstEnums ? "const " : "") + `enum ${toSafeString(ast.standaloneName)} {
` + ast.params.map(({ ast: ast2, keyName }) => keyName + " = " + generateType(ast2, options)).join(",\n") + "\n}";
}
function generateStandaloneInterface(ast, options) {
  return (hasComment(ast) ? generateComment(ast.comment, ast.deprecated) + "\n" : "") + `export interface ${toSafeString(ast.standaloneName)} ` + (ast.superTypes.length > 0 ? `extends ${ast.superTypes.map((superType) => toSafeString(superType.standaloneName)).join(", ")} ` : "") + generateInterface(ast, options);
}
function generateStandaloneType(ast, options) {
  return (hasComment(ast) ? generateComment(ast.comment) + "\n" : "") + `export type ${toSafeString(ast.standaloneName)} = ${generateType(
    (0, import_lodash3.omit)(ast, "standaloneName"),
    options
  )}`;
}
function escapeKeyName(keyName) {
  if (keyName.length && /[A-Za-z_$]/.test(keyName.charAt(0)) && /^[\w$]+$/.test(keyName)) {
    return keyName;
  }
  if (keyName === "[k: string]") {
    return keyName;
  }
  return JSON.stringify(keyName);
}
function getSuperTypesAndParams(ast) {
  return ast.params.map((param) => param.ast).concat(ast.superTypes);
}

// src/normalizer.ts
var import_util = require("util");
var rules = /* @__PURE__ */ new Map();
function hasType(schema, type) {
  return schema.type === type || Array.isArray(schema.type) && schema.type.includes(type);
}
function isObjectType(schema) {
  return schema.properties !== void 0 || hasType(schema, "object") || hasType(schema, "any");
}
function isArrayType(schema) {
  return schema.items !== void 0 || hasType(schema, "array") || hasType(schema, "any");
}
rules.set('Remove `type=["null"]` if `enum=[null]`', (schema) => {
  if (Array.isArray(schema.enum) && schema.enum.some((e) => e === null) && Array.isArray(schema.type) && schema.type.includes("null")) {
    schema.type = schema.type.filter((type) => type !== "null");
  }
});
rules.set("Destructure unary types", (schema) => {
  if (schema.type && Array.isArray(schema.type) && schema.type.length === 1) {
    schema.type = schema.type[0];
  }
});
rules.set("Add empty `required` property if none is defined", (schema) => {
  if (isObjectType(schema) && !("required" in schema)) {
    schema.required = [];
  }
});
rules.set("Transform `required`=false to `required`=[]", (schema) => {
  if (schema.required === false) {
    schema.required = [];
  }
});
rules.set("Default additionalProperties", (schema, _, options) => {
  if (isObjectType(schema) && !("additionalProperties" in schema) && schema.patternProperties === void 0) {
    schema.additionalProperties = options.additionalProperties;
  }
});
rules.set("Transform id to $id", (schema, fileName) => {
  if (!isSchemaLike(schema)) {
    return;
  }
  if (schema.id && schema.$id && schema.id !== schema.$id) {
    throw ReferenceError(
      `Schema must define either id or $id, not both. Given id=${schema.id}, $id=${schema.$id} in ${fileName}`
    );
  }
  if (schema.id) {
    schema.$id = schema.id;
    delete schema.id;
  }
});
rules.set("Add an $id to anything that needs it", (schema, fileName, _options, _key, dereferencedPaths) => {
  if (!isSchemaLike(schema)) {
    return;
  }
  if (!schema.$id && !schema[Parent]) {
    schema.$id = toSafeString(justName(fileName));
    return;
  }
  if (!isArrayType(schema) && !isObjectType(schema)) {
    return;
  }
  const dereferencedName = dereferencedPaths.get(schema);
  if (!schema.$id && !schema.title && dereferencedName) {
    schema.$id = toSafeString(justName(dereferencedName));
  }
  if (dereferencedName) {
    dereferencedPaths.delete(schema);
  }
});
rules.set("Escape closing JSDoc comment", (schema) => {
  escapeBlockComment(schema);
});
rules.set("Add JSDoc comments for minItems and maxItems", (schema) => {
  if (!isArrayType(schema)) {
    return;
  }
  const commentsToAppend = [
    "minItems" in schema ? `@minItems ${schema.minItems}` : "",
    "maxItems" in schema ? `@maxItems ${schema.maxItems}` : ""
  ].filter(Boolean);
  if (commentsToAppend.length) {
    schema.description = appendToDescription(schema.description, ...commentsToAppend);
  }
});
rules.set("Optionally remove maxItems and minItems", (schema, _fileName, options) => {
  if (!isArrayType(schema)) {
    return;
  }
  if ("minItems" in schema && options.ignoreMinAndMaxItems) {
    delete schema.minItems;
  }
  if ("maxItems" in schema && (options.ignoreMinAndMaxItems || options.maxItems === -1)) {
    delete schema.maxItems;
  }
});
rules.set("Normalize schema.minItems", (schema, _fileName, options) => {
  if (options.ignoreMinAndMaxItems) {
    return;
  }
  if (!isArrayType(schema)) {
    return;
  }
  const { minItems } = schema;
  schema.minItems = typeof minItems === "number" ? minItems : 0;
});
rules.set("Remove maxItems if it is big enough to likely cause OOMs", (schema, _fileName, options) => {
  if (options.ignoreMinAndMaxItems || options.maxItems === -1) {
    return;
  }
  if (!isArrayType(schema)) {
    return;
  }
  const { maxItems, minItems } = schema;
  if (maxItems !== void 0 && maxItems - minItems > options.maxItems) {
    delete schema.maxItems;
  }
});
rules.set("Normalize schema.items", (schema, _fileName, options) => {
  if (options.ignoreMinAndMaxItems) {
    return;
  }
  const { maxItems, minItems } = schema;
  const hasMaxItems = typeof maxItems === "number" && maxItems >= 0;
  const hasMinItems = typeof minItems === "number" && minItems > 0;
  if (schema.items && !Array.isArray(schema.items) && (hasMaxItems || hasMinItems)) {
    const items = schema.items;
    const newItems = Array(maxItems || minItems || 0).fill(items);
    if (!hasMaxItems) {
      schema.additionalItems = items;
    }
    schema.items = newItems;
  }
  if (Array.isArray(schema.items) && hasMaxItems && maxItems < schema.items.length) {
    schema.items = schema.items.slice(0, maxItems);
  }
  return schema;
});
rules.set("Remove extends, if it is empty", (schema) => {
  if (!schema.hasOwnProperty("extends")) {
    return;
  }
  if (schema.extends == null || Array.isArray(schema.extends) && schema.extends.length === 0) {
    delete schema.extends;
  }
});
rules.set("Make extends always an array, if it is defined", (schema) => {
  if (schema.extends == null) {
    return;
  }
  if (!Array.isArray(schema.extends)) {
    schema.extends = [schema.extends];
  }
});
rules.set("Transform definitions to $defs", (schema, fileName) => {
  if (schema.definitions && schema.$defs && !(0, import_util.isDeepStrictEqual)(schema.definitions, schema.$defs)) {
    throw ReferenceError(
      `Schema must define either definitions or $defs, not both. Given id=${schema.id} in ${fileName}`
    );
  }
  if (schema.definitions) {
    schema.$defs = schema.definitions;
    delete schema.definitions;
  }
});
rules.set("Transform const to singleton enum", (schema) => {
  if (schema.const !== void 0) {
    schema.enum = [schema.const];
    delete schema.const;
  }
});
function normalize2(rootSchema, dereferencedPaths, filename, options) {
  rules.forEach((rule) => traverse(rootSchema, (schema, key) => rule(schema, filename, options, key, dereferencedPaths)));
  return rootSchema;
}

// src/optimizer.ts
var import_lodash4 = require("lodash");
function optimize(ast, options, processed = /* @__PURE__ */ new Set()) {
  if (processed.has(ast)) {
    return ast;
  }
  processed.add(ast);
  switch (ast.type) {
    case "INTERFACE":
      return Object.assign(ast, {
        params: ast.params.map((_) => Object.assign(_, { ast: optimize(_.ast, options, processed) }))
      });
    case "INTERSECTION":
    case "UNION":
      const optimizedAST = Object.assign(ast, {
        params: ast.params.map((_) => optimize(_, options, processed))
      });
      if (optimizedAST.params.some((_) => _.type === "ANY")) {
        log("cyan", "optimizer", "[A, B, C, Any] -> Any", optimizedAST);
        return T_ANY;
      }
      if (optimizedAST.params.some((_) => _.type === "UNKNOWN")) {
        log("cyan", "optimizer", "[A, B, C, Unknown] -> Unknown", optimizedAST);
        return T_UNKNOWN;
      }
      if (optimizedAST.params.every((_) => {
        const a = generateType(omitStandaloneName(_), options);
        const b = generateType(omitStandaloneName(optimizedAST.params[0]), options);
        return a === b;
      }) && optimizedAST.params.some((_) => _.standaloneName !== void 0)) {
        log("cyan", "optimizer", "[A (named), A] -> [A (named)]", optimizedAST);
        optimizedAST.params = optimizedAST.params.filter((_) => _.standaloneName !== void 0);
      }
      const params = (0, import_lodash4.uniqBy)(optimizedAST.params, (_) => generateType(_, options));
      if (params.length !== optimizedAST.params.length) {
        log("cyan", "optimizer", "[A, B, B] -> [A, B]", optimizedAST);
        optimizedAST.params = params;
      }
      return Object.assign(optimizedAST, {
        params: optimizedAST.params.map((_) => optimize(_, options, processed))
      });
    default:
      return ast;
  }
}
function omitStandaloneName(ast) {
  switch (ast.type) {
    case "ENUM":
      return ast;
    default:
      return { ...ast, standaloneName: void 0 };
  }
}

// src/parser.ts
var import_lodash6 = require("lodash");
var import_util2 = require("util");

// src/typesOfSchema.ts
var import_lodash5 = require("lodash");
function typesOfSchema(schema) {
  if (schema.tsType) {
    return ["CUSTOM_TYPE"];
  }
  const matchedTypes = [];
  for (const [schemaType, f] of Object.entries(matchers)) {
    if (f(schema)) {
      matchedTypes.push(schemaType);
    }
  }
  if (!matchedTypes.length) {
    return ["UNNAMED_SCHEMA"];
  }
  return matchedTypes;
}
var matchers = {
  ALL_OF(schema) {
    return "allOf" in schema;
  },
  ANY(schema) {
    if (Object.keys(schema).length === 0) {
      return true;
    }
    return schema.type === "any";
  },
  ANY_OF(schema) {
    return "anyOf" in schema;
  },
  BOOLEAN(schema) {
    if ("enum" in schema) {
      return false;
    }
    if (schema.type === "boolean") {
      return true;
    }
    if (!isCompound(schema) && typeof schema.default === "boolean") {
      return true;
    }
    return false;
  },
  CUSTOM_TYPE() {
    return false;
  },
  NAMED_ENUM(schema) {
    return "enum" in schema && "tsEnumNames" in schema;
  },
  NAMED_SCHEMA(schema) {
    return "$id" in schema && ("patternProperties" in schema || "properties" in schema);
  },
  NEVER(schema) {
    return schema === false;
  },
  NULL(schema) {
    return schema.type === "null";
  },
  NUMBER(schema) {
    if ("enum" in schema) {
      return false;
    }
    if (schema.type === "integer" || schema.type === "number") {
      return true;
    }
    if (!isCompound(schema) && typeof schema.default === "number") {
      return true;
    }
    return false;
  },
  OBJECT(schema) {
    return schema.type === "object" && !(0, import_lodash5.isPlainObject)(schema.additionalProperties) && !schema.allOf && !schema.anyOf && !schema.oneOf && !schema.patternProperties && !schema.properties && !schema.required;
  },
  ONE_OF(schema) {
    return "oneOf" in schema;
  },
  REFERENCE(schema) {
    return "$ref" in schema;
  },
  STRING(schema) {
    if ("enum" in schema) {
      return false;
    }
    if (schema.type === "string") {
      return true;
    }
    if (!isCompound(schema) && typeof schema.default === "string") {
      return true;
    }
    return false;
  },
  TYPED_ARRAY(schema) {
    if (schema.type && schema.type !== "array") {
      return false;
    }
    return "items" in schema;
  },
  UNION(schema) {
    return Array.isArray(schema.type);
  },
  UNNAMED_ENUM(schema) {
    if ("tsEnumNames" in schema) {
      return false;
    }
    if (schema.type && schema.type !== "boolean" && schema.type !== "integer" && schema.type !== "number" && schema.type !== "string") {
      return false;
    }
    return "enum" in schema;
  },
  UNNAMED_SCHEMA() {
    return false;
  },
  UNTYPED_ARRAY(schema) {
    return schema.type === "array" && !("items" in schema);
  }
};

// src/parser.ts
function parse(schema, options, keyName, processed = /* @__PURE__ */ new Map(), usedNames = /* @__PURE__ */ new Set()) {
  if (isPrimitive(schema)) {
    if (isBoolean(schema)) {
      return parseBooleanSchema(schema, keyName, options);
    }
    return parseLiteral(schema, keyName);
  }
  const types = typesOfSchema(schema);
  if (types.length === 1) {
    const ast2 = parseAsTypeWithCache(schema, types[0], options, keyName, processed, usedNames);
    log("blue", "parser", "Types:", types, "Input:", schema, "Output:", ast2);
    return ast2;
  }
  const ast = parseAsTypeWithCache(
    {
      $id: schema.$id,
      allOf: [],
      description: schema.description,
      title: schema.title
    },
    "ALL_OF",
    options,
    keyName,
    processed,
    usedNames
  );
  ast.params = types.map(
    (type) => (
      // We hoist description (for comment) and id/title (for standaloneName)
      // to the parent intersection type, so we remove it from the children.
      parseAsTypeWithCache(maybeStripNameHints(schema), type, options, keyName, processed, usedNames)
    )
  );
  log("blue", "parser", "Types:", types, "Input:", schema, "Output:", ast);
  return ast;
}
function parseAsTypeWithCache(schema, type, options, keyName, processed = /* @__PURE__ */ new Map(), usedNames = /* @__PURE__ */ new Set()) {
  let cachedTypeMap = processed.get(schema);
  if (!cachedTypeMap) {
    cachedTypeMap = /* @__PURE__ */ new Map();
    processed.set(schema, cachedTypeMap);
  }
  const cachedAST = cachedTypeMap.get(type);
  if (cachedAST) {
    return cachedAST;
  }
  const ast = {};
  cachedTypeMap.set(type, ast);
  return Object.assign(ast, parseNonLiteral(schema, type, options, keyName, processed, usedNames));
}
function parseBooleanSchema(schema, keyName, options) {
  if (schema) {
    return {
      keyName,
      type: options.unknownAny ? "UNKNOWN" : "ANY"
    };
  }
  return {
    keyName,
    type: "NEVER"
  };
}
function parseLiteral(schema, keyName) {
  return {
    keyName,
    params: schema,
    type: "LITERAL"
  };
}
function parseNonLiteral(schema, type, options, keyName, processed, usedNames) {
  const definitions = getDefinitionsMemoized(getRootSchema(schema));
  const keyNameFromDefinition = (0, import_lodash6.findKey)(definitions, (_) => _ === schema);
  switch (type) {
    case "ALL_OF":
      return {
        comment: schema.description,
        deprecated: schema.deprecated,
        keyName,
        standaloneName: standaloneName(schema, keyNameFromDefinition, usedNames),
        params: schema.allOf.map((_) => parse(_, options, void 0, processed, usedNames)),
        type: "INTERSECTION"
      };
    case "ANY":
      return {
        ...options.unknownAny ? T_UNKNOWN : T_ANY,
        comment: schema.description,
        deprecated: schema.deprecated,
        keyName,
        standaloneName: standaloneName(schema, keyNameFromDefinition, usedNames)
      };
    case "ANY_OF":
      return {
        comment: schema.description,
        deprecated: schema.deprecated,
        keyName,
        standaloneName: standaloneName(schema, keyNameFromDefinition, usedNames),
        params: schema.anyOf.map((_) => parse(_, options, void 0, processed, usedNames)),
        type: "UNION"
      };
    case "BOOLEAN":
      return {
        comment: schema.description,
        deprecated: schema.deprecated,
        keyName,
        standaloneName: standaloneName(schema, keyNameFromDefinition, usedNames),
        type: "BOOLEAN"
      };
    case "CUSTOM_TYPE":
      return {
        comment: schema.description,
        deprecated: schema.deprecated,
        keyName,
        params: schema.tsType,
        standaloneName: standaloneName(schema, keyNameFromDefinition, usedNames),
        type: "CUSTOM_TYPE"
      };
    case "NAMED_ENUM":
      return {
        comment: schema.description,
        deprecated: schema.deprecated,
        keyName,
        standaloneName: standaloneName(schema, keyNameFromDefinition ?? keyName, usedNames),
        params: schema.enum.map((_, n) => ({
          ast: parseLiteral(_, void 0),
          keyName: schema.tsEnumNames[n]
        })),
        type: "ENUM"
      };
    case "NAMED_SCHEMA":
      return newInterface(schema, options, processed, usedNames, keyName);
    case "NEVER":
      return {
        comment: schema.description,
        deprecated: schema.deprecated,
        keyName,
        standaloneName: standaloneName(schema, keyNameFromDefinition, usedNames),
        type: "NEVER"
      };
    case "NULL":
      return {
        comment: schema.description,
        deprecated: schema.deprecated,
        keyName,
        standaloneName: standaloneName(schema, keyNameFromDefinition, usedNames),
        type: "NULL"
      };
    case "NUMBER":
      return {
        comment: schema.description,
        deprecated: schema.deprecated,
        keyName,
        standaloneName: standaloneName(schema, keyNameFromDefinition, usedNames),
        type: "NUMBER"
      };
    case "OBJECT":
      return {
        comment: schema.description,
        keyName,
        standaloneName: standaloneName(schema, keyNameFromDefinition, usedNames),
        type: "OBJECT",
        deprecated: schema.deprecated
      };
    case "ONE_OF":
      return {
        comment: schema.description,
        deprecated: schema.deprecated,
        keyName,
        standaloneName: standaloneName(schema, keyNameFromDefinition, usedNames),
        params: schema.oneOf.map((_) => parse(_, options, void 0, processed, usedNames)),
        type: "UNION"
      };
    case "REFERENCE":
      throw Error((0, import_util2.format)("Refs should have been resolved by the resolver!", schema));
    case "STRING":
      return {
        comment: schema.description,
        deprecated: schema.deprecated,
        keyName,
        standaloneName: standaloneName(schema, keyNameFromDefinition, usedNames),
        type: "STRING"
      };
    case "TYPED_ARRAY":
      if (Array.isArray(schema.items)) {
        const minItems2 = schema.minItems;
        const maxItems2 = schema.maxItems;
        const arrayType = {
          comment: schema.description,
          deprecated: schema.deprecated,
          keyName,
          maxItems: maxItems2,
          minItems: minItems2,
          standaloneName: standaloneName(schema, keyNameFromDefinition, usedNames),
          params: schema.items.map((_) => parse(_, options, void 0, processed, usedNames)),
          type: "TUPLE"
        };
        if (schema.additionalItems === true) {
          arrayType.spreadParam = options.unknownAny ? T_UNKNOWN : T_ANY;
        } else if (schema.additionalItems) {
          arrayType.spreadParam = parse(schema.additionalItems, options, void 0, processed, usedNames);
        }
        return arrayType;
      } else {
        return {
          comment: schema.description,
          deprecated: schema.deprecated,
          keyName,
          standaloneName: standaloneName(schema, keyNameFromDefinition, usedNames),
          params: parse(schema.items, options, `{keyNameFromDefinition}Items`, processed, usedNames),
          type: "ARRAY"
        };
      }
    case "UNION":
      return {
        comment: schema.description,
        deprecated: schema.deprecated,
        keyName,
        standaloneName: standaloneName(schema, keyNameFromDefinition, usedNames),
        params: schema.type.map((type2) => {
          const member = { ...(0, import_lodash6.omit)(schema, "$id", "description", "title"), type: type2 };
          return parse(maybeStripDefault(member), options, void 0, processed, usedNames);
        }),
        type: "UNION"
      };
    case "UNNAMED_ENUM":
      return {
        comment: schema.description,
        deprecated: schema.deprecated,
        keyName,
        standaloneName: standaloneName(schema, keyNameFromDefinition, usedNames),
        params: schema.enum.map((_) => parseLiteral(_, void 0)),
        type: "UNION"
      };
    case "UNNAMED_SCHEMA":
      return newInterface(schema, options, processed, usedNames, keyName, keyNameFromDefinition);
    case "UNTYPED_ARRAY":
      const minItems = schema.minItems;
      const maxItems = typeof schema.maxItems === "number" ? schema.maxItems : -1;
      const params = options.unknownAny ? T_UNKNOWN : T_ANY;
      if (minItems > 0 || maxItems >= 0) {
        return {
          comment: schema.description,
          deprecated: schema.deprecated,
          keyName,
          maxItems: schema.maxItems,
          minItems,
          // create a tuple of length N
          params: Array(Math.max(maxItems, minItems) || 0).fill(params),
          // if there is no maximum, then add a spread item to collect the rest
          spreadParam: maxItems >= 0 ? void 0 : params,
          standaloneName: standaloneName(schema, keyNameFromDefinition, usedNames),
          type: "TUPLE"
        };
      }
      return {
        comment: schema.description,
        deprecated: schema.deprecated,
        keyName,
        params,
        standaloneName: standaloneName(schema, keyNameFromDefinition, usedNames),
        type: "ARRAY"
      };
  }
}
function standaloneName(schema, keyNameFromDefinition, usedNames) {
  const name = schema.title || schema.$id || keyNameFromDefinition;
  if (name) {
    return generateName(name, usedNames);
  }
}
function newInterface(schema, options, processed, usedNames, keyName, keyNameFromDefinition) {
  const name = standaloneName(schema, keyNameFromDefinition, usedNames);
  return {
    comment: schema.description,
    deprecated: schema.deprecated,
    keyName,
    params: parseSchema(schema, options, processed, usedNames, name),
    standaloneName: name,
    superTypes: parseSuperTypes(schema, options, processed, usedNames),
    type: "INTERFACE"
  };
}
function parseSuperTypes(schema, options, processed, usedNames) {
  const superTypes = schema.extends;
  if (!superTypes) {
    return [];
  }
  return superTypes.map((_) => parse(_, options, void 0, processed, usedNames));
}
function parseSchema(schema, options, processed, usedNames, parentSchemaName) {
  let asts = (0, import_lodash6.map)(schema.properties, (value, key) => ({
    ast: parse(value, options, key, processed, usedNames),
    isPatternProperty: false,
    isRequired: (0, import_lodash6.includes)(schema.required || [], key),
    isUnreachableDefinition: false,
    keyName: key
  }));
  let singlePatternProperty = false;
  if (schema.patternProperties) {
    singlePatternProperty = !schema.additionalProperties && Object.keys(schema.patternProperties).length === 1;
    asts = asts.concat(
      (0, import_lodash6.map)(schema.patternProperties, (value, key) => {
        const ast = parse(value, options, key, processed, usedNames);
        const comment = `This interface was referenced by \`${parentSchemaName}\`'s JSON-Schema definition
via the \`patternProperty\` "${key}".`;
        ast.comment = ast.comment ? `${ast.comment}

${comment}` : comment;
        return {
          ast,
          isPatternProperty: !singlePatternProperty,
          isRequired: singlePatternProperty || (0, import_lodash6.includes)(schema.required || [], key),
          isUnreachableDefinition: false,
          keyName: singlePatternProperty ? "[k: string]" : key
        };
      })
    );
  }
  if (options.unreachableDefinitions) {
    asts = asts.concat(
      (0, import_lodash6.map)(schema.$defs, (value, key) => {
        const ast = parse(value, options, key, processed, usedNames);
        const comment = `This interface was referenced by \`${parentSchemaName}\`'s JSON-Schema
via the \`definition\` "${key}".`;
        ast.comment = ast.comment ? `${ast.comment}

${comment}` : comment;
        return {
          ast,
          isPatternProperty: false,
          isRequired: (0, import_lodash6.includes)(schema.required || [], key),
          isUnreachableDefinition: true,
          keyName: key
        };
      })
    );
  }
  switch (schema.additionalProperties) {
    case void 0:
    case true:
      if (singlePatternProperty) {
        return asts;
      }
      return asts.concat({
        ast: options.unknownAny ? T_UNKNOWN_ADDITIONAL_PROPERTIES : T_ANY_ADDITIONAL_PROPERTIES,
        isPatternProperty: false,
        isRequired: true,
        isUnreachableDefinition: false,
        keyName: "[k: string]"
      });
    case false:
      return asts;
    default:
      return asts.concat({
        ast: parse(schema.additionalProperties, options, "[k: string]", processed, usedNames),
        isPatternProperty: false,
        isRequired: true,
        isUnreachableDefinition: false,
        keyName: "[k: string]"
      });
  }
}
function getDefinitions(schema, isSchema = true, processed = /* @__PURE__ */ new Set()) {
  if (processed.has(schema)) {
    return {};
  }
  processed.add(schema);
  if (Array.isArray(schema)) {
    return schema.reduce(
      (prev, cur) => ({
        ...prev,
        ...getDefinitions(cur, false, processed)
      }),
      {}
    );
  }
  if ((0, import_lodash6.isPlainObject)(schema)) {
    return {
      ...isSchema && hasDefinitions(schema) ? schema.$defs : {},
      ...Object.keys(schema).reduce(
        (prev, cur) => ({
          ...prev,
          ...getDefinitions(schema[cur], false, processed)
        }),
        {}
      )
    };
  }
  return {};
}
var getDefinitionsMemoized = (0, import_lodash6.memoize)(getDefinitions);
function hasDefinitions(schema) {
  return "$defs" in schema;
}

// src/resolver.ts
var import_json_schema_ref_parser = __toESM(require("@bcherny/json-schema-ref-parser"), 1);
async function dereference(schema, { cwd, $refOptions }) {
  log("green", "dereferencer", "Dereferencing input schema:", cwd, schema);
  const parser = new import_json_schema_ref_parser.default();
  const dereferencedPaths = /* @__PURE__ */ new WeakMap();
  const dereferencedSchema = await parser.dereference(cwd, schema, {
    ...$refOptions,
    dereference: {
      ...$refOptions.dereference,
      onDereference($ref, schema2) {
        dereferencedPaths.set(schema2, $ref);
      }
    }
  });
  return { dereferencedPaths, dereferencedSchema };
}

// src/validator.ts
var rules2 = /* @__PURE__ */ new Map();
rules2.set("Enum members and tsEnumNames must be of the same length", (schema) => {
  if (schema.enum && schema.tsEnumNames && schema.enum.length !== schema.tsEnumNames.length) {
    return false;
  }
});
rules2.set("tsEnumNames must be an array of strings", (schema) => {
  if (schema.tsEnumNames && schema.tsEnumNames.some((_) => typeof _ !== "string")) {
    return false;
  }
});
rules2.set("When both maxItems and minItems are present, maxItems >= minItems", (schema) => {
  const { maxItems, minItems } = schema;
  if (typeof maxItems === "number" && typeof minItems === "number") {
    return maxItems >= minItems;
  }
});
rules2.set("When maxItems exists, maxItems >= 0", (schema) => {
  const { maxItems } = schema;
  if (typeof maxItems === "number") {
    return maxItems >= 0;
  }
});
rules2.set("When minItems exists, minItems >= 0", (schema) => {
  const { minItems } = schema;
  if (typeof minItems === "number") {
    return minItems >= 0;
  }
});
rules2.set("deprecated must be a boolean", (schema) => {
  const typeOfDeprecated = typeof schema.deprecated;
  return typeOfDeprecated === "boolean" || typeOfDeprecated === "undefined";
});
function validate(schema, filename) {
  const errors = [];
  rules2.forEach((rule, ruleName) => {
    traverse(schema, (schema2, key) => {
      if (rule(schema2) === false) {
        errors.push(`Error at key "${key}" in file "${filename}": ${ruleName}`);
      }
      return schema2;
    });
  });
  return errors;
}

// src/index.ts
var import_util3 = require("util");

// src/linker.ts
var import_lodash7 = require("lodash");
function link(schema, parent = null) {
  if (!Array.isArray(schema) && !(0, import_lodash7.isPlainObject)(schema)) {
    return schema;
  }
  if (schema.hasOwnProperty(Parent)) {
    return schema;
  }
  Object.defineProperty(schema, Parent, {
    enumerable: false,
    value: parent,
    writable: false
  });
  if (Array.isArray(schema)) {
    schema.forEach((child) => link(child, schema));
  }
  for (const key in schema) {
    link(schema[key], schema);
  }
  return schema;
}

// src/optionValidator.ts
function validateOptions({ maxItems }) {
  if (maxItems !== void 0 && maxItems < -1) {
    throw RangeError(`Expected options.maxItems to be >= -1, but was given ${maxItems}.`);
  }
}

// src/index.ts
var DEFAULT_OPTIONS = {
  $refOptions: {},
  additionalProperties: true,
  // TODO: default to empty schema (as per spec) instead
  bannerComment: `/* eslint-disable */
/**
* This file was automatically generated by json-schema-to-typescript.
* DO NOT MODIFY IT BY HAND. Instead, modify the source JSONSchema file,
* and run json-schema-to-typescript to regenerate this file.
*/`,
  cwd: process.cwd(),
  declareExternallyReferenced: true,
  enableConstEnums: true,
  format: true,
  ignoreMinAndMaxItems: false,
  maxItems: 20,
  strictIndexSignatures: false,
  style: {
    bracketSpacing: false,
    printWidth: 120,
    semi: true,
    singleQuote: false,
    tabWidth: 2,
    trailingComma: "none",
    useTabs: false
  },
  unreachableDefinitions: false,
  unknownAny: true
};
function compileFromFile(filename, options = DEFAULT_OPTIONS) {
  const contents = Try(
    () => (0, import_fs2.readFileSync)(filename),
    () => {
      throw new ReferenceError(`Unable to read file "${filename}"`);
    }
  );
  const schema = Try(
    () => JSON.parse(contents.toString()),
    () => {
      throw new TypeError(`Error parsing JSON in file "${filename}"`);
    }
  );
  return compile(schema, stripExtension(filename), { cwd: (0, import_path3.dirname)(filename), ...options });
}
async function compile(schema, name, options = {}) {
  validateOptions(options);
  const _options = (0, import_lodash8.merge)({}, DEFAULT_OPTIONS, options);
  const start = Date.now();
  function time() {
    return `(${Date.now() - start}ms)`;
  }
  if (!(0, import_lodash8.endsWith)(_options.cwd, "/")) {
    _options.cwd += "/";
  }
  const _schema = (0, import_lodash8.cloneDeep)(schema);
  const { dereferencedPaths, dereferencedSchema } = await dereference(_schema, _options);
  if (process.env.VERBOSE) {
    if ((0, import_util3.isDeepStrictEqual)(_schema, dereferencedSchema)) {
      log("green", "dereferencer", time(), "\u2705 No change");
    } else {
      log("green", "dereferencer", time(), "\u2705 Result:", dereferencedSchema);
    }
  }
  const linked = link(dereferencedSchema);
  if (process.env.VERBOSE) {
    log("green", "linker", time(), "\u2705 No change");
  }
  const errors = validate(linked, name);
  if (errors.length) {
    errors.forEach((_) => error(_));
    throw new ValidationError();
  }
  if (process.env.VERBOSE) {
    log("green", "validator", time(), "\u2705 No change");
  }
  const normalized = normalize2(linked, dereferencedPaths, name, _options);
  log("yellow", "normalizer", time(), "\u2705 Result:", normalized);
  const parsed = parse(normalized, _options);
  log("blue", "parser", time(), "\u2705 Result:", parsed);
  const optimized = optimize(parsed, _options);
  log("cyan", "optimizer", time(), "\u2705 Result:", optimized);
  const generated = generate(optimized, _options);
  log("magenta", "generator", time(), "\u2705 Result:", generated);
  const formatted = format(generated, _options);
  log("white", "formatter", time(), "\u2705 Result:", formatted);
  return formatted;
}
var ValidationError = class extends Error {
};

// test/testCompileFromFile.ts
function run2() {
  (0, import_ava2.default)("compileFromFile should resolve refs from cwd option", async (t) => t.snapshot(await compileFromFile("./test/resources/other/ReferencingType.json", { cwd: "./test/resources" })));
}

// test/testE2E.ts
var import_ava3 = __toESM(require("ava"), 1);
var import_fs4 = require("fs");
var import_lodash9 = require("lodash");
var import_path5 = require("path");

// test/http.ts
var import_fs3 = require("fs");
var import_http = require("http");
var import_https = require("https");
var import_path4 = require("path");
var CACHE_DIR = "test/__fixtures__";
async function getWithCache(url) {
  const resultFromFilesystem = getFromFilesystem(url);
  if (resultFromFilesystem) {
    return resultFromFilesystem;
  }
  const resultFromNetwork = await getFromNetwork(url);
  writeToFilesystem(url, resultFromNetwork);
  return resultFromNetwork;
}
function getFromFilesystem(url) {
  const filepath = getFilepath(url);
  if (!(0, import_fs3.existsSync)(filepath)) {
    return;
  }
  return JSON.parse((0, import_fs3.readFileSync)(filepath, "utf8"));
}
function getFilepath(url) {
  return (0, import_path4.join)(__dirname, "../../", CACHE_DIR, url.replace(/[:\/\\]/g, "-"));
}
function writeToFilesystem(url, data) {
  const filepath = getFilepath(url);
  console.info(`Writing "${filepath} to filesystem...`);
  (0, import_fs3.writeFileSync)(filepath, JSON.stringify(data, null, 2));
}
function getFromNetwork(url) {
  const f = url.startsWith("https://") ? import_https.get : import_http.get;
  return new Promise((resolve2, reject) => {
    f(url, (res) => {
      const contentType = res.headers["content-type"];
      if (res.statusCode !== 200) {
        return reject(res);
      } else if (contentType && !/^application\/json/.test(contentType)) {
        return reject(new Error(`Invalid content-type.
Expected application/json but received ${contentType}`));
      }
      res.setEncoding("utf8");
      let rawData = "";
      res.on("data", (chunk) => {
        rawData += chunk;
      });
      res.on("end", () => {
        try {
          resolve2(JSON.parse(rawData));
        } catch (e) {
          reject(e);
        }
      });
    }).on("error", (e) => {
      reject(e);
    });
  });
}

// test/testE2E.ts
var dir = __dirname + "/e2e";
function hasOnly() {
  return (0, import_fs4.readdirSync)(dir).filter((_) => /^.*\.js$/.test(_)).map((_) => require((0, import_path5.join)(dir, _))).some((_) => _.only);
}
function run3() {
  const modules = (0, import_fs4.readdirSync)(dir).filter((_) => !_.includes(".ignore.")).filter((_) => /^.*\.js$/.test(_)).map((_) => [_, require((0, import_path5.join)(dir, _))]);
  const only = (0, import_lodash9.find)(modules, (_) => Boolean(_[1].only));
  if (only) {
    runOne(only[1], only[0]);
  } else {
    modules.filter((_) => !_[1].exclude).forEach((_) => runOne(_[1], _[0]));
  }
}
var httpWithCacheResolver = {
  order: 1,
  canRead: /^https?:/i,
  async read({ url }) {
    return await getWithCache(url);
  }
};
function runOne(exports, name) {
  log("blue", "Running test", name);
  const options = (0, import_lodash9.merge)(exports.options, { $refOptions: { resolve: { http: httpWithCacheResolver } } });
  (0, import_ava3.default)(name, async (t) => {
    if (exports.error) {
      try {
        await compile(exports.input, stripExtension(name), options);
      } catch (e) {
        t.true(e instanceof Error);
      }
    } else {
      t.snapshot(
        await compile(exports.input, stripExtension(name), options),
        `Expected output to match snapshot for e2e test: ${name}`
      );
    }
  });
}

// test/testIdempotence.ts
var import_ava4 = __toESM(require("ava"), 1);
var import_lodash10 = require("lodash");
function run4() {
  const SCHEMA = {
    type: "object",
    properties: {
      firstName: {
        type: "string"
      }
    },
    required: ["firstName"]
  };
  (0, import_ava4.default)("compile() should not mutate its input", async (t) => {
    const before = (0, import_lodash10.cloneDeep)(SCHEMA);
    await compile(SCHEMA, "A");
    t.deepEqual(before, SCHEMA);
  });
  (0, import_ava4.default)("compile() should be idempotent", async (t) => {
    const a = await compile(SCHEMA, "A");
    const b = await compile(SCHEMA, "A");
    t.deepEqual(a, b);
  });
}

// test/testLinker.ts
var import_ava5 = __toESM(require("ava"), 1);

// test/e2e/basics.ts
var input = {
  title: "Example Schema",
  type: "object",
  properties: {
    firstName: {
      type: "string"
    },
    lastName: {
      id: "lastName",
      type: "string"
    },
    age: {
      description: "Age in years",
      type: "integer",
      minimum: 0
    },
    height: {
      $id: "height",
      type: "number"
    },
    favoriteFoods: {
      type: "array"
    },
    likesDogs: {
      type: "boolean"
    }
  },
  required: ["firstName", "lastName"]
};

// test/testLinker.ts
function run5() {
  (0, import_ava5.default)("linker should link to each node's parent schema", (t) => {
    const schema = link(input);
    t.is(schema[Parent], null);
    t.is(schema.properties[Parent], schema);
    t.is(schema.properties.firstName[Parent], schema.properties);
    t.is(schema.properties.lastName[Parent], schema.properties);
    t.is(schema.properties.age[Parent], schema.properties);
    t.is(schema.properties.height[Parent], schema.properties);
    t.is(schema.properties.favoriteFoods[Parent], schema.properties);
    t.is(schema.properties.likesDogs[Parent], schema.properties);
    t.is(schema.required[Parent], schema);
  });
}

// test/testNormalizer.ts
var import_ava6 = __toESM(require("ava"), 1);
var import_fs5 = require("fs");
var import_path6 = require("path");
var normalizerDir = __dirname + "/../test/normalizer";
function run6() {
  (0, import_fs5.readdirSync)(normalizerDir).filter((_) => /^.*\.json$/.test(_)).map((_) => (0, import_path6.join)(normalizerDir, _)).map((_) => [_, require(_)]).forEach(([filename, json]) => {
    (0, import_ava6.default)(json.name, (t) => {
      const normalized = normalize2(link(json.in), /* @__PURE__ */ new WeakMap(), filename, json.options ?? DEFAULT_OPTIONS);
      t.deepEqual(json.out, normalized);
    });
  });
}

// test/testUtils.ts
var import_ava7 = __toESM(require("ava"), 1);
function run7() {
  (0, import_ava7.default)("pathTransform", (t) => {
    t.is(pathTransform("types", "schemas", "schemas/foo/a.json"), "types/foo");
    t.is(pathTransform("./schemas/types", "./schemas", "schemas/foo/bar/a.json"), "schemas/types/foo/bar");
    t.is(pathTransform("types", "./src/../types/../schemas", "schemas/foo/a.json"), "types/foo");
  });
  (0, import_ava7.default)("generateName", (t) => {
    const usedNames = /* @__PURE__ */ new Set();
    t.is(generateName("a", usedNames), "A");
    t.is(generateName("abc", usedNames), "Abc");
    t.is(generateName("ABcd", usedNames), "ABcd");
    t.is(generateName("$Abc_123", usedNames), "$Abc_123");
    t.is(generateName("Abc-de-f", usedNames), "AbcDeF");
    t.is(generateName("a", usedNames), "A1");
    t.is(generateName("a", usedNames), "A2");
    t.is(generateName("a", usedNames), "A3");
  });
  (0, import_ava7.default)("isSchemaLike", (t) => {
    const schema = link({
      title: "Example Schema",
      type: "object",
      properties: {
        firstName: {
          type: "string"
        },
        lastName: {
          id: "lastName",
          type: "string"
        }
      },
      required: ["firstName", "lastName"]
    });
    t.is(isSchemaLike(schema), true);
    t.is(isSchemaLike([]), false);
    t.is(isSchemaLike(schema.properties), false);
    t.is(isSchemaLike(schema.required), false);
    t.is(isSchemaLike(schema.title), false);
    t.is(isSchemaLike(schema.properties.firstName), true);
    t.is(isSchemaLike(schema.properties.lastName), true);
  });
}

// test/test.ts
run3();
if (!hasOnly()) {
  run2();
  run();
  run4();
  run5();
  run6();
  run7();
}
